import yt_dlp
import tempfile

tempdir = tempfile.gettempdir()

def invoke_hook(prog, hook):
    if 'total_bytes' in prog:
        hook(prog['filename'], prog['info_dict']['title'], prog['status'], prog['downloaded_bytes'], prog['total_bytes'])
    elif 'total_bytes_estimate' in prog:
        hook(prog['filename'], prog['info_dict']['title'], prog['status'], prog['downloaded_bytes'], prog['total_bytes_estimate'])
    else:
        hook(prog['filename'], prog['info_dict']['title'], prog['status'], prog['downloaded_bytes'], 0)

def download(url, on_progress):
    
    OPTS = {
        'format': 'bestaudio[ext=m4a]/best[ext=mp4]/best',
        'outtmpl': f'{tempdir}/download-%(epoch)s.%(ext)s',
        'playlist_items': '1:1:1',
        'progress_hooks': [lambda prog : invoke_hook(prog, on_progress)],
        'postprocessors': [],
    }

    with yt_dlp.YoutubeDL(OPTS) as ydl:
        err = ydl.download(url)

__all__ = [
    'download',
]
